# -*- coding:Utf-8 -*-

import es
import os
from configobj import ConfigObj

__version__ = 'v1.0'

info = es.AddonInfo()
info.name     = 'Bombsite Editor'
info.version  = __version__
info.url      = ''
info.basename = 'bs_editor'
info.author   = 'UltiNaruto'
eventscripts_currentmap = es.ServerVar('eventscripts_currentmap')
admins = []
bombsites = []
bombsite_info = { 'id' : 0, 'name' : None, 'x' : 0, 'y' : 0, 'z' : 0 }

def load():
	es.msg('#green', '[%s] %s Loaded' % (info.name, info.version))
	init()
	es.remove('func_bomb_target')
	
def unload():
	es.msg('#lightgreen', '[%s] %s Unloaded' % (info.name, info.version))
	clear()
	
def init():
	global bombsites
	bombsites = [None]*9
	
def clear():
	global bombsites
	del bombsites
	
def add_bombsite(userid, temp_bs_name):
	global bombsites
	bsr = None
	for i in range(1,9):
		if bombsites[i] == None:
			bsr = i
			break
		else:
			bsr = None
	
	if bsr==None:
		es.tell(userid, 'ERROR : The 8 bombsites are already set')
		return

	bombsites[bsr] = dict(bombsite_info)
	bombsites[bsr]['id'] = es.createentity('func_bomb_target')
	es.entitysetvalue(bombsites[bsr]['id'], 'model', 'maps/%s.bsp' % str(eventscripts_currentmap))
	x, y, z = es.getplayerlocation(userid)
	bombsites[bsr]['name'] = temp_bs_name
	bombsites[bsr]['x'] = x
	bombsites[bsr]['y'] = y
	bombsites[bsr]['z'] = z
	cfg = open(es.getAddonPath('bs_editor') + '/maps/%s/%s.ini' % (str(eventscripts_currentmap), bsr),"w")
	cfg.write('name = ' + temp_bs_name)
	cfg.write("\n")
	cfg.write('x = %s' % x)
	cfg.write("\n")	
	cfg.write('y = %s' % y)
	cfg.write("\n")
	cfg.write('z = %s' % z)
	es.entitysetvalue(bombsites[bsr]['id'], 'origin', '%s %s %s' % (x, y, z + 32))
	es.spawnentity(bombsites[bsr]['id'])
	m_vecMins_x = -200
	m_vecMins_y = -200
	m_vecMins_z = -25
	m_vecMaxs_x = 200
	m_vecMaxs_y = 200
	m_vecMaxs_z = 25
	es.setindexprop(bombsites[bsr]['id'], 'CBaseEntity.m_Collision.m_vecMins', '%s, %s, %s' % (m_vecMins_x,m_vecMins_y,m_vecMins_z))
	es.setindexprop(bombsites[bsr]['id'], 'CBaseEntity.m_Collision.m_vecMaxs', '%s, %s, %s' % (m_vecMaxs_x,m_vecMaxs_y,m_vecMaxs_z))
	es.tell(userid, 'INFO : Bombsite %s has been added' % temp_bs_name)
	
def add_bombsite_at(temp_bs_name, x, y ,z):
	global bombsites
	bsr = None
	for i in range(1,9):
		if bombsites[i] == None:
			bsr = i
			break
		else:
			bsr = None
	
	if bsr==None:
		return

	bombsites[bsr] = dict(bombsite_info)
	bombsites[bsr]['id'] = es.createentity('func_bomb_target')
	es.entitysetvalue(bombsites[bsr]['id'], 'model', 'maps/%s.bsp' % str(eventscripts_currentmap))
	bombsites[bsr]['name'] = temp_bs_name
	bombsites[bsr]['x'] = x
	bombsites[bsr]['y'] = y
	bombsites[bsr]['z'] = z
	es.entitysetvalue(bombsites[bsr]['id'], 'origin', '%s %s %s' % (x, y, z + 32))
	es.spawnentity(bombsites[bsr]['id'])
	m_vecMins_x = -200
	m_vecMins_y = -200
	m_vecMins_z = -25
	m_vecMaxs_x = 200
	m_vecMaxs_y = 200
	m_vecMaxs_z = 25
	es.setindexprop(bombsites[bsr]['id'], 'CBaseEntity.m_Collision.m_vecMins', '%s, %s, %s' % (m_vecMins_x,m_vecMins_y,m_vecMins_z))
	es.setindexprop(bombsites[bsr]['id'], 'CBaseEntity.m_Collision.m_vecMaxs', '%s, %s, %s' % (m_vecMaxs_x,m_vecMaxs_y,m_vecMaxs_z))
	
def del_bombsite(userid, temp_bs_name):
	global bombsites
	bsr = None
	for i in range(1,9):
		if bombsites[i]!=None:
			if bombsites[i]['name']==temp_bs_name:
				bsr = i
				break
			else:
				bsr = None
			
	if bsr==None:
		es.tell(userid, "ERROR : Bombsite %s doesn't exists" % temp_bs_name)
		return
		
	es.remove(bombsites[bsr]['id'])
	bombsites[bsr] = None
	es.tell(userid, 'INFO : Bombsite %s has been deleted' % temp_bs_name)
	
def player_say(ev):
	global admins
	text = ev['text']
	if str(ev['steamid']) in admins:
		if text.startswith('!bs_add'):
			arg = text.split(' ')
			add_bombsite(ev['userid'], arg[1])
		if text.startswith('!bs_del'):
			arg = text.split(' ')
			del_bombsite(ev['userid'], arg[1])
	else:
		es.tell(ev['userid'], '#green', "You're not authorized to use this command")
		
def es_map_start(ev):
	global admin
	if os.path.isfile(es.getAddonPath('bs_editor') + '/cfg/admins.cfg'):
		admin_cfg = ConfigObj(es.getAddonPath('bs_editor') + '/cfg/admins.cfg')
		admins = str(admin_cfg['steamid']).split(";")
	for i in range(1,9):
		if os.path.isfile(es.getAddonPath('bs_editor') + '/maps/%s/%s.ini' % (str(ev['mapname']), i)):
			cfg = ConfigObj(es.getAddonPath('bs_editor') + '/maps/%s/%s.ini' % (str(ev['mapname']), i))
			add_bombsite_at(str(cfg['name']), float(cfg['x']), float(cfg['y']) ,float(cfg['z']))
		admin_cfg = None
			